<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { Breadcrumb } from '../../../interfaces';
import { SlpBreadcrumb } from '~/components/common/index.vue';

interface HeroImage {
  src: string;
  alt?: string;
}

interface HeroButton {
  text: string;
  externalUrl: string;
  variation?: string;
  iconName: string;
  iconVariant: string;
}

export default Vue.extend({
  components: {
    SlpBreadcrumb,
  },
  props: {
    header: {
      type: String,
      required: true,
    },
    subtitle: {
      type: String,
      required: false,
      default: '',
    },
    text: {
      type: String,
      required: true,
    },
    location: {
      type: String,
      required: true,
    },
    image: {
      type: Object as PropType<HeroImage>,
      required: true,
    },
    cta: {
      type: Object as PropType<HeroButton>,
      required: false,
      default: null,
    },
    breadcrumbs: {
      type: Array as PropType<Breadcrumb[]>,
      required: false,
      default: null,
    },
    registrationClosed: {
      type: Boolean,
      required: false,
      default: false,
    },
    expandHeader: {
      type: Boolean,
      required: false,
      default: false,
    },
    gitlabLogo: {
      type: Boolean,
      required: false,
      default: false,
    },
    date: {
      type: String,
      required: false,
      default: '',
    },
  },
  computed: {
    formattedBreadcrumbs() {
      return this.breadcrumbs
        ? this.breadcrumbs.map((crumb) => {
            if (crumb.title && crumb.title === 'Devsecops World Tour') {
              return {
                ...crumb,
                title: 'DevSecOps World Tour',
              };
            }
            return crumb;
          })
        : null;
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <SlpContainer>
      <div class="hero-wrapper">
        <div class="hero-text" :class="{ 'hero-text--expand': expandHeader }">
          <SlpBreadcrumb
            v-if="breadcrumbs"
            class="slp-mb-32 breadcrumbs"
            :crumbs="formattedBreadcrumbs"
          />
          <div class="city__gitlab-logo">
            <img
              src="https://images.ctfassets.net/xz1dnu24egyd/1tHsfp1UKNZPdULa6HZgFH/9942d52a305a25f743207a26aed091e0/gitlablogo.svg"
              alt=""
            />
          </div>
          <SlpTypography
            v-if="header"
            variant="heading1-bold"
            tag="h1"
            class="slp-mb-24"
            >{{ header }}</SlpTypography
          >
          <span class="location slp-mb-24"
            ><SlpIcon variant="product" name="location" size="sm" />
            <div
              v-if="text"
              variant="body1"
              class="address"
              v-html="$md.render(text)"
            ></div>
          </span>
          <SlpButton
            v-if="!registrationClosed && cta.text"
            :href="cta.externalUrl"
            :variant="cta.variation"
            class="cta"
            >{{ cta.text }}
            <SlpIcon
              v-if="cta.iconName"
              :variant="cta.iconVariant"
              :name="cta.iconName"
              class="slp-ml-8"
          /></SlpButton>
        </div>
        <div v-if="image?.src" class="hero-image">
          <img :src="image.src" :alt="image.alt" />
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  margin-bottom: 96px;

  background-size: 50%;
  background-color: #2f2a6b;
}
.city__gitlab-logo {
  width: 141px;
  img {
    width: 100%;
  }
}
.hero-wrapper {
  display: flex;
  flex-direction: column-reverse;
  align-items: center;
  gap: 32px;
  // margin-top: $spacing-32;
  padding: 70px 0;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    justify-content: space-around;
    align-items: center;
  }
  @media (min-width: $breakpoint-lg) {
    // gap: 132px;
    justify-content: space-between;
  }

  .hero-text {
    min-width: 30%;
    position: relative;
    color: #fff;
    @media (min-width: $breakpoint-md) {
      padding: 60px 0;
    }
    &:before {
      display: none;
      content: '';
      position: absolute;
      left: 0;
      top: 0;
      width: 100%;
      height: 100%;
      background: url('/nuxt-images/events/world-tour/dso-world-tour-hero.png');
      background-repeat: no-repeat;
      background-size: 100% auto;
      z-index: 0;
      pointer-events: none;
      @media (min-width: $breakpoint-md) {
        display: block;
        left: -14%;
        top: 20px;
        width: 104%;
        height: 100%;
      }
      > * {
        position: relative;
        z-index: 1;
      }
    }

    &--expand {
      min-width: 45%;
    }
    .cta {
      white-space: nowrap;
    }
    .breadcrumbs {
      display: none;
      :deep {
        a[href] {
          span {
            color: white;
          }
        }
        span {
          color: #a2a1a6;
        }
      }
      //   :deep(span) {
      //   color: white;
      //   white-space: nowrap;

      // }

      @media (min-width: $breakpoint-md) {
        display: flex;
      }
    }
    .location {
      display: flex;
      flex-direction: row;
      gap: 8px;
      @media (min-width: $breakpoint-lg) {
        white-space: nowrap;
      }

      .address:deep(p) {
        font-weight: 400;
        font-size: 20px;
        line-height: 24px;
      }
    }
    @media (min-width: $breakpoint-md) {
      flex: 1 0 33%;
    }
  }
  .hero-image {
    width: 100%;
    text-align: center;
    @media (min-width: $breakpoint-md) {
      max-width: 65%;
      flex: 0 0 58%;
    }
    img {
      margin-bottom: -7px;
      max-width: 100%;

      @media (min-width: $breakpoint-lg) {
        max-width: unset;
        width: 100%;
      }
    }
    @media (min-width: $breakpoint-md) {
      margin: 0;
    }
  }
}
</style>
